﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.Linq;

namespace ReadOnlyGridViewExceptLastRow
{
    public class Product : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public int productID;
        public string name;
        public int productTypeId;

        public int ProductID
        {
            get { return this.productID; }
            set
            {
                if (value != this.productID)
                {
                    this.productID = value;
                    this.OnPropertyChanged("ProductID");
                }
            }
        }


        public string Name
        {
            get { return this.name; }
            set
            {
                if (value != this.name)
                {
                    this.name = value;
                    this.OnPropertyChanged("Name");
                }
            }
        }

        public int ProductTypeId
        {
            get { return this.productTypeId; }
            set
            {
                if (value != this.productTypeId)
                {
                    this.productTypeId = value;
                    this.OnPropertyChanged("ProductTypeId");
                }
            }
        }

        public Product()
        {

        }

        private Random rand = new Random();

        public Product(string name)
        {
            this.name = name;
            this.productTypeId = rand.Next(1, ProductType.GetProductTypes().Count);
        }

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }

        public override string ToString()
        {
            return this.Name;
        }

        public static ObservableCollection<Product> GetProducts()
        {
            ObservableCollection<Product> products = new ObservableCollection<Product>();
            Product product;

            // Liverpool
            product = new Product("Coca-Cola");
            products.Add(product);

            // Manchester Utd.
            product = new Product("IKEA Table");
            products.Add(product);

            // Chelsea
            product = new Product("Othe Product");
            products.Add(product);

            // Arsenal
            product = new Product("McDonalds");
            products.Add(product);

            return products;
        }
    }
}
